convert.to.pwm = function(x){
  temp.split = unlist(strsplit(x,split = ""))
  temp.pwm = matrix(0,20,length(temp.split))
  rownames(temp.pwm) = aa.set
  for(i in 1:length(temp.split)) temp.pwm[temp.split[i],i] = temp.pwm[temp.split[i],i] + 1
  return(temp.pwm)
}
multi.pfm = function(x){
  temp.str = strsplit(x,split = "")
  temp.pwm = Reduce("+",lapply(temp.str,convert.to.pwm))
  return(temp.pwm)
}
pwm.score = function(x,pwm){
  temp.str = strsplit(x,split = "")
  temp.pwm = lapply(temp.str,convert.to.pwm)
  temp.score=  unlist(lapply(temp.pwm,function(y) sum(y * pwm)))
  return(temp.score)
}



compute.trend = function(round.counts,cores = 8){
  
  temp.rc = as.data.frame(t(round.counts))
  colnames(temp.rc)[1:ncol(temp.rc)] = "seq"
  temp.rc$round = 1:nrow(temp.rc)
  return(unlist(mclapply(X = 1:(ncol(temp.rc) - 1),FUN = function(x){
    temp.lm = lm(seq ~ round,temp.rc[,c(x,ncol(temp.rc))])
    return(temp.lm$coefficients["round"])
  },mc.cores = cores)))
  
}

compute.stepwise.trend = function(round.counts,cores= 6,dist = "exp",round.num = 4
                                  ,min.count = 0){
  
  counts.table = round.counts
  counts.table$stepwise.trend = 0
  temp = counts.table[counts.table$Round_2 <= min.count,]
  counts.table[counts.table$Round_2 <= min.count,"stepwise.trend"] = 
rank( -1 * (rowMeans(temp[,3:4]) + rowMeans(temp[,5:6] * 2) - .25 * temp$Round_0) ) + 
    3 * nrow(counts.table)
  temp = counts.table[counts.table$Round_2 > min.count & counts.table$Round_3 <= min.count,]
  counts.table[counts.table$Round_2 > min.count & counts.table$Round_3 <= min.count,"stepwise.trend"] = 
    rank(-compute.trend(round.counts = temp[,paste0("Round_",0:2)])) + 2 * nrow(counts.table)
  temp =counts.table[counts.table$Round_3 > min.count & counts.table$Round_4 <= min.count,]
  counts.table[counts.table$Round_3 > min.count & counts.table$Round_4 <= min.count,"stepwise.trend"] = 
    rank(-compute.trend(round.counts = temp[,paste0("Round_",0:3)])) + 1 * nrow(counts.table)
  if(round.num == 4){
    temp =counts.table[counts.table$Round_4 > min.count,]
    counts.table[counts.table$Round_4 > min.count,"stepwise.trend"] = 
      rank(-compute.trend(round.counts = temp[,paste0("Round_",0:4)]))
  }
    counts.table$stepwise.trend = floor(rank(-counts.table$stepwise.trend))
  counts.table$stepwise.trend = (counts.table$stepwise.trend - 1) / length(counts.table$stepwise.trend)
  
  if(dist == "norm") counts.table$stepwise.trend = qnorm(counts.table$stepwise.trend)
  if(dist == "exp") counts.table$stepwise.trend = qexp(counts.table$stepwise.trend,rate = 2.2)
  if(dist == "rlnorm") counts.table$stepwise.trend = qlnorm(counts.table$stepwise.trend,sdlog = .35)
  
  return(counts.table$stepwise.trend)
}


numeric.to.seq = function(x){
  
  seq.len = ncol(x) /20
  seq.mat = matrix("",nrow(x),seq.len)
  for(i in 1:seq.len){
    
    temp = x[,((i - 1) * 20 + 1):(i * 20)]
    y = as.numeric(temp[1,])
    seq.mat[,i] = apply(temp,1,function(y){
      
      aa.set[as.logical(y)]
      
    })
  }
  return(apply(seq.mat,1,function(x) paste(x,collapse="")))
}

onehot.to.seq = function(onehot.mat){
  
  temp.mat = onehot.mat
  temp.mat$end = 1
  temp.mat = t(temp.mat)
  aa.set.temp = rep(aa.set
                    ,ncol(onehot.mat) / 20)
  aa.set.temp = c(aa.set.temp,"|")
  aa.set.temp = rep(aa.set.temp,nrow(onehot.mat))
  test = paste(aa.set.temp[as.logical(as.numeric(temp.mat))],collapse="")
  return(unlist(strsplit(test,split = "|",fixed=T)))
}
create.pfm.onehot = function(onehot.mat,create.pfm = T){
  
  out.mat = matrix(0,20,ncol(onehot.mat) / 20)
  rownames(out.mat) = aa.set
  colnames(out.mat) = paste("Pos_",1:ncol(out.mat),sep="")
  for(i in 1:ncol(out.mat)){
    out.mat[,i] = colSums(onehot.mat[,((i - 1) * 20 + 1):(i * 20)])
  }
  if(create.pfm) out.mat = out.mat / nrow(onehot.mat)
}
score.onehot = function(onehot.mat,pwm){
  pwm.flat = as.numeric(pwm)
  temp.mat = t(onehot.mat)
  test = temp.mat * pwm.flat
  return(colSums(test))
}
blosum.to.roundseq = function(seq,sub.mat,rownames=T,feature.length = 20){
  temp.all = seq
  temp.all = unlist(strsplit(paste(temp.all,collapse=""),split=  ""))
  temp.mat = as.matrix(sub.mat[,temp.all])
  temp.mat = matrix(as.numeric(temp.mat),ncol = nchar(seq[1]) * feature.length,byrow = T)
  if(rownames) rownames(temp.mat) = seq
  return(as.data.frame(temp.mat))
}
create_lookup_data =  function(seq,lookup.tbl,uneven = F,mat.col = peptide.length,add.rownames = T){
  temp.all = as.character(seq)
  if(uneven){
    lookup.tbl = c(lookup.tbl,"0")
    names(lookup.tbl)[length(lookup.tbl)] = "X"
    char.max = max(nchar(temp.all))
    temp.all = unlist(lapply(temp.all
                             ,function(x)
                               paste0(x
                                      ,paste0(rep("X",char.max-nchar(x)),collapse=""))))
    mat.col = char.max
  }
  
  temp.all = unlist(strsplit(paste(temp.all,collapse=""),split=  ""))
  length(unique(temp.all))
  # temp.mat = as.matrix(aa.lookup[temp.all])
  temp.mat = as.matrix(lookup.tbl[temp.all])
  temp.mat = matrix(as.numeric(temp.mat),ncol = mat.col,byrow = T)
  if(add.rownames) rownames(temp.mat) = seq
  return(as.data.frame(temp.mat))
}


blosum.to.seq = function(seq){
  blosum.map = rep(aa.set,2)
  names(blosum.map) = c(apply(blosum,1,function(x)paste(x, collapse=""))
                        ,apply(blosum,2,function(x)paste(x, collapse=""))
  )
  
  blosum.map = blosum.map[!duplicated(names(blosum.map))]
  
  seq = t(as.matrix(seq))
  seq = as.numeric(seq)
  
  seq = split(seq, ceiling(seq_along(seq)/20))
  seq = unlist(lapply(seq,function(x)paste(x,collapse="")))
  seq.char = blosum.map[seq]
  seq.char = split(seq.char, ceiling(seq_along(seq.char)/peptide.length))
  return(unlist(lapply(seq.char,function(x)paste(x,collapse=""))))
  
}


